                        TITLE V-MISCELLANEOUS PROVISIONS

 SEC. 501. CONSTRUCTION.

    (a) IN GENERAL.-Except as otherwise provided in this Act, nothing in this 
 Act shall be construed to apply a lesser standard than the standards applied 
 under title V of the Rehabilitation Act of 1973 (29 U.S.C. 790 et seq.) or 
 the regulations issued by Federal agencies pursuant to such title. 
    (b) RELATIONSHIP TO OTHER LAWS.-Nothing in this Act shall be construed to 
 invalidate or limit the remedies, rights, and procedures of any Federal law 
 or law of any State or political subdivision of any State or jurisdiction 
 that provides greater or equal protection for the rights of individuals with 
 disabilities than are afforded by this Act. Nothing in this Act shall be 
 construed to preclude the prohibition of, or the imposition of restrictions 
 on, smoking in places of employment covered by title I, in transportation 
 covered by title II or III, or in places of public accommodation covered by 
 title III. 
    (c) INSURANCE.-Titles I through IV of this Act shall not be construed to
 prohibit or restrict-
    (1) an insurer, hospital or medical service company, health maintenance
 organization, or any agent, or entity that administers benefit plans, or
 similar organizations from underwriting risks, classifying risks, or
 administering such risks that are based on or not inconsistent with State law;
 or
    (2) a person or organization covered by this Act from establishing,
 sponsoring, observing or administering the terms of a bona fide benefit plan 
 that are based on underwriting risks, classifying risks, or administering 
 such risks that are based on or not inconsistent with State law; or 
    (3) a person or organization covered by this Act from establishing, 
 sponsoring, observing or administering the terms of a bona fide benefit plan 
 that is not subject to State laws that regulate insurance. 
    Paragraphs (1), (2), and (3) shall not be used as a subterfuge to evade 
 the purposes of title I and III. 
    (d) ACCOMMODATIONS AND SERVICES.-Nothing in this Act shall be construed to 
 require an individual with a disability to accept an accommodation, aid, 
 service, opportunity, or benefit which such individual chooses not to accept. 

 SEC. 502. STATE IMMUNITY.

    A State shall not be immune under the eleventh amendment to the 
 Constitution of the United States from an action in Federal or State court of 
 competent jurisdiction for a violation of this Act. In any action against a 
 State for a violation of the requirements of this Act, remedies (including 
 remedies both at law and in equity) are available for such a violation to the 
 same extent as such remedies are available for such a violation in an action 
 against any public or private entity other than a State. 

 SEC. 503. PROHIBITION AGAINST RETALIATION AND COERCION.

    (a) RETALIATION.-No person shall discriminate against any individual 
 because such individual has opposed any act or practice made unlawful by this 
 Act or because such individual made a charge, testified, assisted, or 
 participated in any manner in an investigation, proceeding, or hearing under 
 this Act. 
    (b) INTERFERENCE, COERCION, OR INTIMIDATION.-It shall be unlawful to 
 coerce, intimidate, threaten, or interfere with any individual in the 
 exercise or enjoyment of, or on account of his or her having exercised or 
 enjoyed, or on account of his or her having aided or encouraged any other 
 individual in the exercise or enjoyment of, any right granted or protected by 
 this Act. 
    (c) REMEDIES AND PROCEDURES.-The remedies and procedures available under 
 sections 107, 203, and 308 of this Act shall be available to aggrieved 
 persons for violations of subsections (a) and (b), with respect to title I, 
 title II and title III, respectively. 

 SEC. 504. REGULATIONS BY THE ARCHITECTURAL AND TRANSPORTATION BARRIERS
 COMPLIANCE BOARD.

    (a) ISSUANCE OF GUIDELINES.-Not later than 9 months after the date of 
 enactment of this Act, the Architectural and Transportation Barriers 
 Compliance Board shall issue minimum guidelines that shall supplement the 
 existing Minimum Guidelines and Requirements for Accessible Design for 
 purposes of titles II and III of this Act. 
    (b) CONTENTS OF GUIDELINES.-The supplemental guidelines issued under 
 subsection (a) shall establish additional requirements, consistent with this 
 Act, to ensure that buildings, facilities, rail passenger cars, and vehicles 
 are accessible, in terms of architecture and design, transportation, and 
 communication, to individuals with disabilities. 
    (c) QUALIFIED HISTORIC PROPERTIES.-
    (1) IN GENERAL.-The supplemental guidelines issued under subsection (a) 
 shall include procedures and requirements for alterations that will threaten 
 or destroy the historic significance of qualified historic buildings and 
 facilities as defined in 4.1.7(1)(a) of the Uniform Federal Accessibility 
 Standards. 
    (2) SITES ELIGIBLE FOR LISTING IN NATIONAL REGISTER.-With respect to 
 alterations of buildings or facilities that are eligible for listing in the 
 National Register of Historic Places under the National Historic Preservation 
 Act (16 U.S.C. 470 et seq.), the guidelines described in paragraph (1) shall, 
 at a minimum, maintain the procedures and requirements established in 
 4.1.7(1) and (2) of the Uniform Federal Accessibility Standards. 
    (3) OTHER SITES.-With respect to alterations of buildings or facilities 
 designated as historic under State or local law, the guidelines described in 
 paragraph (1) shall establish procedures equivalent to those established by 
 4.1.7(1)(b) and (c) of the Uniform Federal Accessibility Standards, and shall 
 require, at a minimum, compliance with the requirements established in 
 4.1.7(2) of such standards. 

 SEC. 505. ATTORNEY'S FEES.

    In any action or administrative proceeding commenced pursuant to this Act,
 the court or agency, in its discretion, may allow the prevailing party, other
 than the United States, a reasonable attorney's fee, including litigation
 expenses, and costs, and the United States shall be liable for the foregoing
 the same as a private individual.

 SEC. 506. TECHNICAL ASSISTANCE.

    (a) PLAN FOR ASSISTANCE.-
    (1) IN GENERAL.-Not later than 180 days after the date of enactment of 
 this Act, the Attorney General, in consultation with the Chair of the Equal 
 Employment Opportunity Commission, the Secretary of Transportation, the Chair 
 of the Architectural and Transportation Barriers Compliance Board, and the 
 Chairman of the Federal Communications Commission, shall develop a plan to 
 assist entities covered under this Act, and other Federal agencies, in 
 understanding the responsibility of such entities and agencies under this 
 Act. 
    (2) PUBLICATION OF PLAN.-The Attorney General shall publish the plan 
 referred to in paragraph (1) for public comment in accordance with subchapter 
 II of chapter 5 of title 5, United States Code (commonly known as the 
 Administrative Procedure Act). 
    (b) AGENCY AND PUBLIC ASSISTANCE.-The Attorney General may obtain the 
 assistance of other Federal agencies in carrying out subsection (a), 
 including the National Council on Disability, the President's Committee on 
 Employment of People with Disabilities, the Small Business Administration, 
 and the Department of Commerce. 
    (c) IMPLEMENTATION.-
    (1) RENDERING ASSISTANCE.-Each Federal agency that has responsibility 
 under paragraph (2) for implementing this Act may render technical assistance 
 to individuals and institutions that have rights or duties under the 
 respective title or titles for which such agency has responsibility. 
    (2) IMPLEMENTATION OF TITLES.-
    (A) TITLE I.-The Equal Employment Opportunity Commission and the Attorney 
 General shall implement the plan for assistance developed under subsection 
 (a), for title I. 
    (B) TITLE II.-
    (i) SUBTITLE A.-The Attorney General shall implement such plan for
 assistance for subtitle A of title II.
    (ii) SUBTITLE B.-The Secretary of Transportation shall implement such plan
 for assistance for subtitle B of title II. 
    (C) TITLE III.-The Attorney General, in coordination with the Secretary of 
 Transportation and the Chair of the Architectural Transportation Barriers 
 Compliance Board, shall implement such plan for assistance for title III, 
 except for section 304, the plan for assistance for which shall be 
 implemented by the Secretary of Transportation. 
    (D) TITLE IV.-The Chairman of the Federal Communications Commission, in
 coordination with the Attorney General, shall implement such plan for
 assistance for title IV.
    (3) TECHNICAL ASSISTANCE MANUALS.-Each Federal agency that has 
 responsibility under paragraph (2) for implementing this Act shall, as part 
 of its implementation responsibilities, ensure the availability and provision 
 of appropriate technical assistance manuals to individuals or entities with 
 rights or duties under this Act no later than six months after applicable 
 final regulations are published under titles I, II, III, and IV. 
    (d) GRANTS AND CONTRACTS.-
    (1) IN GENERAL.-Each Federal agency that has responsibility under 
 subsection (c)(2) for implementing this Act may make grants or award 
 contracts to effectuate the purposes of this section, subject to the 
 availability of appropriations. Such grants and contracts may be awarded to 
 individuals, institutions not organized for profit and no part of the net 
 earnings of which inures to the benefit of any private shareholder or 
 individual (including educational institutions), and associations 
 representing individuals who have rights or duties under this Act. Contracts 
 may be awarded to entities organized for profit, but such entities may not be 
 the recipients or grants described in this paragraph. 
    (2) DISSEMINATION OF INFORMATION.-Such grants and contracts, among other
 uses, may be designed to ensure wide dissemination of information about the
 rights and duties established by this Act and to provide information and
 technical assistance about techniques for effective compliance with this Act.
    (e) FAILURE TO RECEIVE ASSISTANCE.-An employer, public accommodation, or
 other entity covered under this Act shall not be excused from compliance with
 the requirements of this Act because of any failure to receive technical
 assistance under this section, including any failure in the development or
 dissemination of any technical assistance manual authorized by this section.

 SEC. 507. FEDERAL WILDERNESS AREAS.

    (a) STUDY.-The National Council on Disability shall conduct a study and 
 report on the effect that wilderness designations and wilderness land 
 management practices have on the ability of individuals with disabilities to 
 use and enjoy the National Wilderness Preservation System as established 
 under the Wilderness Act (16 U.S.C. 1131 et seq.). 
    (b) SUBMISSION OF REPORT.-Not later than 1 year after the enactment of 
 this Act, the National Council on Disability shall submit the report required 
 under subsection (a) to Congress. 
    (c) SPECIFIC WILDERNESS ACCESS.-
    (1) IN GENERAL.-Congress reaffirms that nothing in the Wilderness Act is 
 to be construed as prohibiting the use of a wheelchair in a wilderness area 
 by an individual whose disability requires use of a wheelchair, and 
 consistent with the Wilderness Act no agency is required to provide any form 
 of special treatment or accommodation, or to construct any facilities or 
 modify any conditions of lands within a wilderness area in order to 
 facilitate such use. 
    (2) DEFINITION.-For purposes of paragraph (1), the term "wheelchair" means 
 a device designed solely for use by a mobility-impaired person for 
 locomotion, that is suitable for use in an indoor pedestrian area. 

 SEC. 508. TRANSVESTITES.

    For the purposes of this Act, the term "disabled" or "disability" shall 
 not apply to an individual solely because that individual is a transvestite. 

 SEC. 509. COVERAGE OF CONGRESS AND THE AGENCIES OF THE LEGISLATIVE BRANCH.

    (a) COVERAGE OF THE SENATE.-
    (1) COMMITMENT TO RULE XLII.-The Senate reaffirms its commitment to Rule
 XLII of the Standing Rules of the Senate which provides as follows:
    "No member, officer, or employee of the Senate shall, with respect to
 employment by the Senate or any office thereof-
    "(a) fail or refuse to hire an individual;
    "(b) discharge an individual; or 
    "(c) otherwise discriminate against an individual with respect to 
 promotion, compensation, or terms, conditions, or privileges of employment 
    on the basis of such individual's race, color, religion, sex, national
 origin, age, or state of physical handicap.".
    (2) APPLICATION TO SENATE EMPLOYMENT.-The rights and protections provided 
 pursuant to this Act, the Civil Rights Act of 1990 (S. 2104, 101st Congress), 
 the Civil Rights Act of 1964, the Age Discrimination in Employment Act of 
 1967, and the Rehabilitation Act of 1973 shall apply with respect to 
 employment by the United States Senate. 
    (3) INVESTIGATION AND ADJUDICATION OF CLAIMS.-All claims raised by any 
 individual with respect to Senate employment, pursuant to the Acts referred 
 to in paragraph (2), shall be investigated and adjudicated by the Select 
 Committee on Ethics, pursuant to S. Res. 338, 88th Congress, as amended, or 
 such other entity as the Senate may designate. 
    (4) RIGHTS OF EMPLOYEES.-The Committee on Rules and Administration shall 
 ensure that Senate employees are informed of their rights under the Acts 
 referred to in paragraph (2). 
    (5) APPLICABLE REMEDIES.-When assigning remedies to individuals found to 
 have a valid claim under the Acts referred to in paragraph (2), the Select 
 Committee on Ethics, or such other entity as the Senate may designate, should 
 to the extent practicable apply the same remedies applicable to all other 
 employees covered by the Acts referred to in paragraph (2). Such remedies 
 shall apply exclusively. 
    (6) MATTERS OTHER THAN EMPLOYMENT.-
    (A) IN GENERAL.-The rights and protections under this Act shall, subject 
 to subparagraph (B), apply with respect to the conduct of the Senate 
 regarding matters other than employment. 
    (B) REMEDIES.-The Architect of the Capitol shall establish remedies and 
 procedures to be utilized with respect to the rights and protections provided 
 pursuant to subparagraph (A). Such remedies and procedures shall apply 
 exclusively, after approval in accordance with subparagraph (C). 
    (C) PROPOSED REMEDIES AND PROCEDURES.-For purposes of subparagraph (B), 
 the Architect of the Capitol shall submit proposed remedies and procedures to 
 the Senate Committee on Rules and Administration. The remedies and procedures 
 shall be effective upon the approval of the Committee on Rules and 
 Administration. 
    (7) EXERCISE OF RULEMAKING POWER.-Notwithstanding any other provision of 
 law, enforcement and adjudication of the rights and protections referred to 
 in paragraph (2) and (6)(A) shall be within the exclusive jurisdiction of the 
 United States Senate. The provisions of paragraphs (1), (3), (4), (5), 
 (6)(B), and (6)(C) are enacted by the Senate as an exercise of the rulemaking 
 power of the Senate, with full recognition of the right of the Senate to 
 change its rules, in the same manner, and to the same extent, as in the case 
 of any other rule of the Senate. 
    (b) COVERAGE OF THE HOUSE OF REPRESENTATIVES.-
    (1) IN GENERAL.-Notwithstanding any other provision of this Act or of law,
 the purposes of this Act shall, subject to paragraphs (2) and (3), apply in
 their entirety to the House of Representatives.
    (2) EMPLOYMENT IN THE HOUSE.-
    (A) APPLICATION.-The rights and protections under this Act shall, subject 
 to subparagraph (B), apply with respect to any employee in an employment 
 position in the House of Representatives and any employing authority of the 
 House of Representatives. 
    (B) ADMINISTRATION.-
    (i) IN GENERAL.-In the administration of this paragraph, the remedies and 
 procedures made applicable pursuant to the resolution described in clause 
 (ii) shall apply exclusively. 
    (ii) RESOLUTION.-The resolution referred to in clause (i) is House 
 Resolution 15 of the One Hundredth First Congress, as agreed to January 3, 
 1989, or any other provision that continues in effect the provisions of, or 
 is a successor to, the Fair Employment Practices Resolution (House Resolution 
 558 of the One Hundredth Congress, as agreed to October 4, 1988). 
    (C) EXERCISE OF RULEMAKING POWER.-The provisions of subparagraph (B) are 
 enacted by the House of Representatives as an exercise of the rulemaking 
 power of the House of Representatives, with full recognition of the right of 
 the House to change its rules, in the same manner, and to the same extent as 
 in the case of any other rule of the House. 
    (3) MATTERS OTHER THAN EMPLOYMENT.-
    (A) IN GENERAL.-The rights and protections under this Act shall, subject 
 to subparagraph (B), apply with respect to the conduct of the House of 
 Representatives regarding matters other than employment. 
    (B) REMEDIES.-The Architect of the Capitol shall establish remedies and 
 procedures to be utilized with respect to the rights and protections provided 
 pursuant to subparagraph (A). Such remedies and procedures shall apply 
 exclusively, after approval in accordance with subparagraph (C). 
    (C) APPROVAL.-For purposes of subparagraph (B), the Architect of the 
 Capitol shall submit proposed remedies and procedures to the Speaker of the 
 House of Representatives. The remedies and procedures shall be effective upon 
 the approval of the Speaker, after consultation with the House Office 
 Building Commission. 
    (c) INSTRUMENTALITIES OF CONGRESS.-
    (1) IN GENERAL.-The rights and protections under this Act shall, subject 
 to paragraph (2), apply with respect to the conduct of each instrumentality 
 of the Congress. 
    (2) ESTABLISHMENT OF REMEDIES AND PROCEDURES BY INSTRUMENTALITIES.-The 
 chief official of each instrumentality of the Congress shall establish 
 remedies and procedures to be utilized with respect to the rights and 
 protections provided pursuant to paragraph (1). Such remedies and procedures 
 shall apply exclusively. 
    (3) REPORT TO CONGRESS.-The chief official of each instrumentality of the
 Congress shall, after establishing remedies and procedures for purposes of
 paragraph (2), submit to the Congress a report describing the remedies and
 procedures.
    (4) DEFINITION OF INSTRUMENTALITIES.-For purposes of this section, 
 instrumentalities of the Congress include the following: the Architect of the 
 Capitol, the Congressional Budget Office, the General Accounting Office, the 
 Government Printing Office, the Library of Congress, the Office of Technology 
 Assessment, and the United States Botanic Garden. 
    (5) CONSTRUCTION.-Nothing in this section shall alter the enforcement 
 procedures for individuals with disabilities provided in the General 
 Accounting Office Personnel Act of 1980 and regulations promulgated pursuant 
 to that Act. 

 SEC. 510. ILLEGAL USE OF DRUGS.

    (a) IN GENERAL.-For purposes of this Act, the term "individual with a 
 disability" does not include an individual who is currently engaging in the 
 illegal use of drugs, when the covered entity acts on the basis of such use. 
    (b) RULES OF CONSTRUCTION.-Nothing in subsection (a) shall be construed to
 exclude as an individual with a disability an individual who-
    (1) has successfully completed a supervised drug rehabilitation program 
 and is no longer engaging in the illegal use of drugs, or has otherwise been 
 rehabilitated successfully and is no longer engaging in such use; 
    (2) is participating in a supervised rehabilitation program and is no 
 longer engaging in such use; or 
    (3) is erroneously regarded as engaging in such use, but is not engaging 
 in such use; 
    except that it shall not be a violation of this Act for a covered entity 
 to adopt or administer reasonable policies or procedures, including but not 
 limited to drug testing, designed to ensure that an individual described in 
 paragraph (1) or (2) is no longer engaging in the illegal use of drugs; 
 however, nothing in this section shall be construed to encourage, prohibit, 
 restrict, or authorize the conducting of testing for the illegal use of 
 drugs. 
    (c) HEALTH AND OTHER SERVICES.-Notwithstanding subsection (a) and section
 511(b)(3), an individual shall not be denied health services, or services
 provided in connection with drug rehabilitation, on the basis of the current
 illegal use of drugs if the individual is otherwise entitled to such services.
    (d) DEFINITION OF ILLEGAL USE OF DRUGS.-
    (1) IN GENERAL.-The term "illegal use of drugs" means the use of drugs, 
 the possession or distribution of which is unlawful under the Controlled 
 Substances Act (21 U.S.C. 812). Such term does not include the use of a drug 
 taken under supervision by a licensed health care professional, or other uses 
 authorized by the Controlled Substances Act or other provisions of Federal 
 law. 
    (2) DRUGS.-The term "drug" means a controlled substance, as defined in
 schedules I through V of section 202 of the Controlled Substances Act.

 SEC. 511. DEFINITIONS.

    (a) HOMOSEXUALITY AND BISEXUALITY.-For purposes of the definition of 
 "disability" in section 3(2), homosexuality and bisexuality are not 
 impairments and as such are not disabilities under this Act. 
    (b) CERTAIN CONDITIONS.-Under this Act, the term "disability" shall not 
 include-
    (1) transvestism, transsexualism, pedophilia, exhibitionism, voyeurism,
 gender identity disorders not resulting from physical impairments, or other
 sexual behavior disorders;
    (2) compulsive gambling, kleptomania, or pyromania; or
    (3) psychoactive substance use disorders resulting from current illegal use
 of drugs.

 SEC. 512. AMENDMENTS TO THE REHABILITATION ACT.

    (a) DEFINITION OF HANDICAPPED INDIVIDUAL.-Section 7(8) of the 
 Rehabilitation Act of 1973 (29 U.S.C. 706(8)) is amended by redesignating 
 subparagraph (C) as subparagraph (D), and by inserting after subparagraph (B) 
 the following subparagraph: 
    "(C)(i) For purposes of title V, the term 'individual with handicaps' does 
 not include an individual who is currently engaging in the illegal use of 
 drugs, when a covered entity acts on the basis of such use. 
    "(ii) Nothing in clause (i) shall be construed to exclude as an individual
 with handicaps an individual who-
    "(I) has successfully completed a supervised drug rehabilitation program 
 and is no longer engaging in the illegal use of drugs, or has otherwise been 
 rehabilitated successfully and is no longer engaging in such use; 
    "(II) is participating in a supervised rehabilitation program and is no
 longer engaging in such use; or
    "(III) is erroneously regarded as engaging in such use, but is not 
 engaging in such use; 
    except that it shall not be a violation of this Act for a covered entity 
 to adopt or administer reasonable policies or procedures, including but not 
 limited to drug testing, designed to ensure that an individual described in 
 subclause (I) or (II) is no longer engaging in the illegal use of drugs. 
    "(iii) Notwithstanding clause (i), for purposes of programs and activities 
 providing health services and services provided under titles I, II and III, an 
 individual shall not be excluded from the benefits of such programs or 
 activities on the basis of his or her current illegal use of drugs if he or 
 she is otherwise entitled to such services. 
    "(iv) For purposes of programs and activities providing educational 
 services, local educational agencies may take disciplinary action pertaining 
 to the use or possession of illegal drugs or alcohol against any handicapped 
 student who currently is engaging in the illegal use of drugs or in the use 
 of alcohol to the same extent that such disciplinary action is taken against 
 nonhandicapped students. Furthermore, the due process procedures at 34 CFR 
 104.36 shall not apply to such disciplinary actions. 
    "(v) For purposes of sections 503 and 504 as such sections relate to 
 employment, the term 'individual with handicaps' does not include any 
 individual who is an alcoholic whose current use of alcohol prevents such 
 individual from performing the duties of the job in question or whose 
 employment, by reason of such current alcohol abuse, would constitute a 
 direct threat to property or the safety of others.". 
    (b) DEFINITION OF ILLEGAL DRUGS.-Section 7 of the Rehabilitation Act of 
 1973 (29 U.S.C. 706) is amended by adding at the end the following new 
 paragraph: 
    "(22)(A) The term 'drug' means a controlled substance, as defined in 
 schedules I through V of section 202 of the Controlled Substances Act (21 
 U.S.C. 812). 
    "(B) The term 'illegal use of drugs' means the use of drugs, the 
 possession or distribution of which is unlawful under the Controlled 
 Substances Act. Such term does not include the use of a drug taken under 
 supervision by a licensed health care professional, or other uses authorized 
 by the Controlled Substances Act or other provisions of Federal law.". 
    (c) CONFORMING AMENDMENTS.-Section 7(8)(B) of the Rehabilitation Act of 
 1973 (29 U.S.C. 706(8)(B)) is amended-
    (1) in the first sentence, by striking "Subject to the second sentence of 
 this subparagraph," and inserting "Subject to subparagraphs (C) and (D),"; 
 and 
    (2) by striking the second sentence. 

 SEC. 513. ALTERNATIVE MEANS OF DISPUTE RESOLUTION.

    Where appropriate and to the extent authorized by law, the use of
 alternative means of dispute resolution, including settlement negotiations,
 conciliation, facilitation, mediation, factfinding, minitrials, and
 arbitration, is encouraged to resolve disputes arising under this Act.

 SEC. 514. SEVERABILITY.

    Should any provision in this Act be found to be unconstitutional by a 
 court of law, such provision shall be severed from the remainder of the Act, 
 and such action shall not affect the enforceability of the remaining 
 provisions of the Act. 
 
